<?php
/**
 * Clase Base DP para BaseCrTelefonoOperadorDP
 *
 * @package    
 * @subpackage BaseCrTelefonoOperadorDP
 * @author     Willy
 * @version    SVN:: BaseCrTelefonoOperadorDP.class.php,v 1.1 2014-10-30 10:20:41 william.taype Exp $
 */
abstract class BaseCrTelefonoOperadorDP extends CrTelefonoOperadorBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrTelefonoOperadorBN )
    {
      $o_CrTelefonoOperadorBN = $bSetDefault;
      if($o_CrTelefonoOperadorBN->getIdOperador()) : $this->setIdOperador($o_CrTelefonoOperadorBN->getIdOperador()); endif;
      if($o_CrTelefonoOperadorBN->getDescripcion()) : $this->setDescripcion($o_CrTelefonoOperadorBN->getDescripcion()); endif;
      if($o_CrTelefonoOperadorBN->getEstado()) : $this->setEstado($o_CrTelefonoOperadorBN->getEstado()); endif;
      if($o_CrTelefonoOperadorBN->getLogo()) : $this->setLogo($o_CrTelefonoOperadorBN->getLogo()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(IdOperador),(MAX(IdOperador)+1), 1) AS Maximo FROM cr_telefono_operador;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdOperador($row[0]);

      if($this->getIdOperador()){
        $a_Fields = array();

        if($this->getIdOperador()) : $a_Fields['IdOperador'] = ($this->getIdOperador()); endif;
        if($this->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getDescripcion()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;
        if($this->getLogo()) : $a_Fields['Logo'] = ($this->getLogo()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_telefono_operador (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdOperador())
      {
        $a_Fields = array();

        if($this->getIdOperador()) : $a_Fields['IdOperador'] = ($this->getIdOperador()); endif;
        if($this->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getDescripcion()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;
        if($this->getLogo()) : $a_Fields['Logo'] = ($this->getLogo()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_telefono_operador SET ".$sStringField." WHERE 1 AND IdOperador='".$this->getIdOperador()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdOperador())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_telefono_operador WHERE 1 AND IdOperador='".$this->getIdOperador()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vIdOperador)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdOperador, Descripcion, Estado, Logo FROM cr_telefono_operador WHERE 1 AND IdOperador='".$vIdOperador."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrTelefonoOperadorDP = new CrTelefonoOperadorDP();
    $o_CrTelefonoOperadorDP->setIdOperador($o_propel->IdOperador);
    $o_CrTelefonoOperadorDP->setDescripcion($o_propel->Descripcion);
    $o_CrTelefonoOperadorDP->setEstado($o_propel->Estado);
    $o_CrTelefonoOperadorDP->setLogo($o_propel->Logo);
    return $o_CrTelefonoOperadorDP;
  }
}